#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int r(float, int)
{
	return rand()%1001;
}

int triangly(float f, int i)
{
	return (int)(((f * 3) - floor(f * 3) )*900);
}

int xsin(float f, int i)
{
	f *= M_PI;
	return (int) (sin(f) * 1000);
}

int third(float f, int i)
{
	return i % 3 == 0 ? 500 : 0;
}

int dec(float f, int i)
{
	return (int )(999.0f * (1.0f-f));
}

int inc(float f, int i)
{
	return (int) (999.0f * f);
}

int c1000(float f, int i) { return 1000; }

int half(float f, int i) { return f > 0.5 ? 1000 : 0; }

void g(
	int test_num,
	int k,
	int n,
	int (*fun)(float,int)
) {
	char filename[32];
	sprintf(filename, "bus.%02d.in", test_num);
	FILE *f = fopen(filename, "wt");
	fprintf(f, "%d %d\n", n, k);
	for (int i = 0; i < n; i++) {
		if (i) fprintf(f, " ");
		fprintf(f, "%d", fun((float)i/(float)n, i));
	}
	fprintf(f, "\n");
	fclose(f);
}

void g(
	int test_num,
	int k,
	int n,
	const char *s
) {
	char filename[32];
	sprintf(filename, "bus.%02d.in", test_num);
	FILE *f = fopen(filename, "wt");
	fprintf(f, "%d %d\n%s\n", n, k, s);
	fclose(f);
}


int main(void)
{
	g( 1,    3,   21, "0  0  0  0  0  0  1  2  3  4  1  2  1  4  3  2  1  0  0  0  0");
	g( 2,    2,  100,        r);
	g( 3,   10,  150, triangly);
	g( 4,    5,  200,     xsin);
	g( 5,  400,  500,    third);
	g( 6,  100,  500,      dec);
	g( 7,  250, 1000,      inc);
	g( 8, 1000, 1000,    c1000);
	g( 9,  333, 1000,        r);
	g(10,  900, 1000,        r);
	return 0;
}
