#include <iostream>
#include <iomanip>
#include <queue>
#include <vector>

using namespace std;

const int nmax=10000;
const int mmax=10000;
const int inf=100000000; 
int n, m, s1, s2;
int mini=inf;
vector<int> xs1, ys1;
vector<int> xs2, ys2;
int flag1[nmax][mmax];
int flag2[nmax][mmax];

void bfs1(int x, int y)  
{    queue<int> qx, qy;
     flag1[x][y]=0;
     qx.push(x); 
     qy.push(y); 
     while (qx.size()>0)
       {  int px=qx.front();
          qx.pop();
          int py=qy.front();
          qy.pop();         
          for(int i=0; i<xs1.size(); i++)
            {  int u=px+xs1[i];
               int v=py+ys1[i];
               if ( u >= 0 && u <= n &&  v >=0 && v <= m && flag1[u][v] == -1)
                 { qx.push(u);
                   qy.push(v);
                   flag1[u][v]=flag1[px][py]+1;
                 }
            }
        } 
}   

void bfs2(int x, int y)  
{    queue<int> qx, qy;
     flag2[x][y]=0;
     if (flag1[x][y] != -1) mini=flag1[x][y];
     qx.push(x); 
     qy.push(y); 
     while (qx.size()>0)
       {  int px=qx.front();
          qx.pop();
          int py=qy.front();
          qy.pop();         
          for(int i=0; i<xs2.size(); i++)
            {  int u = px+xs2[i];
               int v = py+ys2[i];
               if ( u >= 0 && u <= n &&  v >=0 && v <= m && flag2[u][v] == -1)
                 { qx.push(u);
                   qy.push(v);
                   flag2[u][v]=flag2[px][py]+1;
                   if (flag1[u][v] != -1 && flag1[u][v]+flag2[u][v] < mini) 
                   mini=flag1[u][v]+flag2[u][v];
                 }
            }
        } 
}   
int main()

{   int x1, y1, x2, y2;
    cin >> n >> m;
    for(int i=0; i <= n; i++)
      for(int j=0; j<= m; j++)
        { flag1[i][j]=-1;
          flag2[i][j]=-1;
        }
    cin >> x1 >> y1 >> s1;
    cin >> x2 >> y2 >> s2;
    
    int x=0, y=s1, f=0;
    xs1.push_back(x);  ys1.push_back(y);
    xs1.push_back(x);  ys1.push_back(-y);
    xs1.push_back(y);  ys1.push_back(x);
    xs1.push_back(-y); ys1.push_back(x);
    while (x < y)
    { if (f < 0) { f = f + 2*x +1; x++;}
      else { f = f - 2*y +1 ; y--;}
      if (f == 0) 
        { xs1.push_back(x);  ys1.push_back(y);
          xs1.push_back(x);  ys1.push_back(-y);
          xs1.push_back(-x); ys1.push_back(y);
          xs1.push_back(-x); ys1.push_back(-y);
          xs1.push_back(y);  ys1.push_back(x);
          xs1.push_back(y);  ys1.push_back(-x);
          xs1.push_back(-y); ys1.push_back(x);
          xs1.push_back(-y); ys1.push_back(-x);
        }
    }
     
    x=0, y=s2; 
    f=0;
    xs2.push_back(x);  ys2.push_back(y);
    xs2.push_back(x);  ys2.push_back(-y);
    xs2.push_back(y);  ys2.push_back(x);
    xs2.push_back(-y); ys2.push_back(x);
    while (x < y)
    { if (f < 0) { f = f + 2*x +1; x++;}
      else { f = f - 2*y +1 ; y--;}
      if (f == 0) 
        { xs2.push_back(x);  ys2.push_back(y);
          xs2.push_back(x);  ys2.push_back(-y);
          xs2.push_back(-x); ys2.push_back(y);
          xs2.push_back(-x); ys2.push_back(-y);
          xs2.push_back(y);  ys2.push_back(x);
          xs2.push_back(y);  ys2.push_back(-x);
          xs2.push_back(-y); ys2.push_back(x);
          xs2.push_back(-y); ys2.push_back(-x);
        }
    } 
    
    bfs1(x1,y1); 
    bfs2(x2,y2);
 /* for(int i=0; i<=n; i++)
      { for(int j=0; j<=m; j++)
          cout << setw(3) << flag1[i][j];
        cout << endl;
      }
    cout << endl;  
    for(int i=0; i<=n; i++)
      { for(int j=0; j<=m; j++)
          cout << setw(3) << flag2[i][j];
        cout << endl;
      } */
    if (mini == inf) cout << 0 << endl;
    else cout << mini << endl;
    return 0; 
    
}
