#include <iostream>
#include <queue>
#include <vector>

using namespace std;

const int nmax=2000;
const int mmax=2000;
int n, m, s1, s2;

vector<int> xs1, ys1;
vector<int> xs2, ys2;
int flag[nmax][mmax];
int level[nmax][mmax];

void diofeq(int s, vector<int>& xs, vector<int>& ys)
{   int x=0, y=s, f=0; 
    xs.push_back(x);  ys.push_back(y);
    xs.push_back(x);  ys.push_back(-y);
    xs.push_back(y);  ys.push_back(x);
    xs.push_back(-y); ys.push_back(x);
    while (x < y)
    { if (f < 0) { f = f + 2*x +1; x++;}
      else { f = f - 2*y +1 ; y--;}
      if (f == 0) 
        { xs.push_back(x);  ys.push_back(y);
          xs.push_back(x);  ys.push_back(-y);
          xs.push_back(-x); ys.push_back(y);
          xs.push_back(-x); ys.push_back(-y);
          xs.push_back(y);  ys.push_back(x);
          xs.push_back(y);  ys.push_back(-x);
          xs.push_back(-y); ys.push_back(x);
          xs.push_back(-y); ys.push_back(-x);
        }
    }
}

void bfs(int x, int y, int xx, int yy)  
{    queue<int> qx, qy;
     flag[x][y]=1; level[x][y]=0;
     qx.push(x); 
     qy.push(y); 
     while (qx.size()>0 && flag[xx][yy]==0)
       {  int px=qx.front(); qx.pop();
          int py=qy.front(); qy.pop();
          if (flag[px][py]==1)         
            for(int i=0; i<xs1.size(); i++)
              {  int u=px+xs1[i];
                 int v=py+ys1[i];
                 if (u >= 0 && u <= n &&  v >=0 && v <= m && flag[u][v] == 0)
                   { qx.push(u); qy.push(v);
                     flag[u][v]=1; level[u][v]=level[px][py]+1;
                   }
              }
          for(int i=0; i<xs2.size(); i++)
            {  int u=px+xs2[i];
               int v=py+ys2[i];
               if (u >= 0 && u <= n &&  v >=0 && v <= m && flag[u][v] == 0)
                 { qx.push(u); qy.push(v);
                   flag[u][v]=2; level[u][v]=level[px][py]+1;
                 }
            } 
     }
}   


int main()

{   int x1, y1, x2, y2;
    cin >> n >> m;
    cin >> x1 >> y1 >> s1;
    cin >> x2 >> y2 >> s2;
   
    diofeq(s1, xs1, ys1);
    diofeq(s2, xs2, ys2);
    
    bfs(x1, y1, x2, y2); 
   
    if (flag[x2][y2] == 0) cout << 0 << endl;
    else cout << level[x2][y2] << endl;
    return 0; 
    
}
